import urllib2

def quote(s):
    return '"' + s + '"'

def array_fmt(l):
    return '[' + ', '.join((quote(s) for s in l)) + ']'

sample_query_str = '''
(let [patient-dataset (car (query {:select [[:field.id :patient] [:dataset.id :dataset]]
                                   :from [:dataset]
                                   :left-join [:field [:= :dataset_id :dataset.id]]
                                   :where [:and [:= :cohort %s]
                                                [:= :field.name "_PATIENT"]]}))
      patient (:PATIENT patient-dataset)
      dataset (:DATASET patient-dataset)
      sample (:ID (car (query {:select [:field.id]
                               :from [:field]
                               :where [:and [:= :dataset_id dataset]
                                            [:= :field.name "sampleID"]]})))
      N (- (/ (:N (car (query {:select [[#sql/call [:sum #sql/call [:length :scores]] :N]]
                  :from [:field_score]
                  :join [:scores [:= :scores_id :scores.id]]
                  :where [:= :field_id patient]}))) 4) 1)]
  (map :SAMPLE (query {:select [:sample]
                       :from [{:select [[#sql/call [:unpackValue patient, :x] :patient]
                                        [#sql/call [:unpackValue sample, :x]  :sample]]
                               :from [#sql/call [:system_range 0 N]]}]
                       :where [:in :patient %s]})))
'''

def patient_to_sample_query(cohort, patients):
    """Return a xena query which looks up sample ids for the given patients."""
    return sample_query_str % (quote(cohort), array_fmt(patients))

headers = { 'Content-Type' : "text/plain" }

def xena_post(host, query):
    """POST a xena query to the given host."""
    req = urllib2.Request(host + '/data/', query, headers)
    response = urllib2.urlopen(req)
    result = response.read()
    return result


##########################

# Basic query example. Queries are scheme expressions. This should print "3.0".
#print xena_post("http://cancerdb:7200", "(+ 1 2)")

# This should print the sample ids for the given patients in TCGA LGG.
print xena_post("https://cancer-beta/proj/public/xena",
                 patient_to_sample_query("TCGA.LGG.sampleMap",
                                         ["TCGA-CS-4938",
                                          "TCGA-HT-7693",
                                          "TCGA-CS-6665",
                                          "TCGA-S9-A7J2",
                                          "TCGA-FG-A6J3"]))
